import json
import math
import time

from datetime import datetime
from fischertechnik.mqtt.Client import Client as MqttClient
from fischertechnik.mqtt.Constants import CONTROLLER_ID
from lib.controller import *
from lib.display import *


h = None
ts = None
pressure = None
temperature = None
humidity = None
p0 = None


def datetimestamp():
    global h, ts, pressure, temperature, humidity, p0
    ts = datetime.now().strftime("%Y-%m-%dT%H:%M:%S.%f")[:-3] + "Z"
    return ts


h = 125
MqttClient.getInstance().connect()
while True:
    if (MqttClient.getInstance().is_connected()):
        break
    time.sleep(0.010)
while True:
    pressure = TXT_M_I2C_1_environment_sensor.get_pressure()
    temperature = TXT_M_I2C_1_environment_sensor.get_temperature()
    humidity = TXT_M_I2C_1_environment_sensor.get_humidity()
    display.set_attr("humidity.text", str(''.join([str(x) for x in ['Humidity: ', round(humidity, 1), ' %']])))
    display.set_attr("temperature.text", str(''.join([str(x2) for x2 in ['Temperature: ', round(temperature, 1), ' °C']])))
    p0 = (((temperature + 273.15) + 0.0065 * h) / (temperature + 273.15)) ** 5.255 * pressure
    display.set_attr("pressure.text", str(''.join([str(x3) for x3 in ['Pressure: ', round(pressure, 1), ' hPa (', round(p0, 1), ' hPa to NN)']])))
    if p0 < 980:
        display.set_attr("forecast.text", str('Forecast: Rain'))
    elif p0 > 1020:
        display.set_attr("forecast.text", str('Forecast: Fair'))
    else:
        display.set_attr("forecast.text", str('Forecast: Change'))
    MqttClient.getInstance().publish("/j1/txt/" + str(CONTROLLER_ID) +"/i/bme680", '{{"ts":"{}","t":{},"h":{},"p":{}}}'.format(datetimestamp(), TXT_M_I2C_1_environment_sensor.get_temperature(), TXT_M_I2C_1_environment_sensor.get_humidity(), TXT_M_I2C_1_environment_sensor.get_pressure()))
    time.sleep(1)


